"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var _ = require("underscore");
var Form = (function (_super) {
    __extends(Form, _super);
    function Form() {
        _super.apply(this, arguments);
        /** This array should list all armstrongs form components by Classname. It lets us optimize the date we pass to the form */
        this.supportedElements = ["TextInput", "CheckboxInput", "SelectInput", "RadioInput", "CalendarInput", "AutoCompleteInput", "TimeInput", "DateInput", "ToggleInput"];
    }
    Form.prototype.recursiveCloneChildren = function (children, data, context) {
        var _this = this;
        return React.Children.map(children, function (child) {
            /** If the child isn't an object, simply return it */
            if (!_.isObject(child)) {
                return child;
            }
            /** Check if the child is one of our form elements. If so, give it context and data */
            var needsContext = typeof child.type === "function" && _.contains(_this.supportedElements, child.type["name"]);
            if (typeof child.type === "function" && _.contains(_this.supportedElements, child.type["name"])) {
                needsContext = true;
            }
            var childProps = { data: needsContext ? data : null, context: needsContext ? context : null };
            if (child.props.children) {
                childProps["children"] = _this.recursiveCloneChildren(child.props.children, data, context);
            }
            return React.cloneElement(child, childProps);
        });
    };
    Form.prototype.render = function () {
        /** Get the parent container to force update. If this ever breaks, just pass 'this' through manually in the parent. */
        var context = this["_reactInternalInstance"]._currentElement._owner._instance;
        var data = this.props.entity;
        var attrs = _.omit(this.props, "entity");
        /** Next map all the supported children, and give them the parent for updating and the model to pick and update fields from. */
        return (React.createElement("form", __assign({}, attrs), this.recursiveCloneChildren(this.props.children, data, context)));
    };
    return Form;
}(React.Component));
exports.Form = Form;
