/// <reference types="react" />
import * as React from "react";
import { IFormBinding } from "./../binder";
export interface IDateInputProps extends React.HTMLProps<DateInput> {
    /** ((string) => void) Event which returns the date when it changes and is valid */
    yearsFromNow?: number;
    /** (boolean) Should the picker let you choose years from the future rather than the past */
    futureDates?: boolean;
}
export interface IDateInputState {
    day?: number;
    month?: number;
    year?: number;
    date?: string;
}
export declare class DateInput extends React.Component<IDateInputProps & IFormBinding, IDateInputState> {
    private cId;
    constructor();
    getDaysArrayByMonth(): string[];
    dayChanged(day: string): void;
    monthChanged(month: string): void;
    yearChanged(year: string): void;
    componentWillMount(): void;
    componentWillReceiveProps(newProps: IDateInputProps & IFormBinding): void;
    change(): void;
    buildDate(): void;
    createDate(): string;
    render(): JSX.Element;
}
