"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var _ = require("underscore");
var classNames = require("classnames");
var binder_1 = require("./../binder");
var RadioInput = (function (_super) {
    __extends(RadioInput, _super);
    function RadioInput() {
        _super.apply(this, arguments);
    }
    RadioInput.prototype.change = function (e) {
        binder_1.Binder.handleChange(this.props.prop, e.target["value"], "number", this.props.data);
        this.props.context.forceUpdate();
    };
    RadioInput.prototype.render = function () {
        var _this = this;
        var id = "radio_" + this.props.prop + "_" + this.props.value;
        var attrs = _.omit(this.props, "prop", "type", "value", "data", "context", "label");
        return (React.createElement("div", {className: classNames("radio", this.props.className)}, 
            React.createElement("input", __assign({}, attrs, {id: id, type: "radio", name: this.props.prop, onChange: function (e) { return _this.change(e); }, value: this.props.value, defaultChecked: this.props.value === this.props.data[this.props.prop]})), 
            React.createElement("label", {htmlFor: id}), 
            React.createElement("label", {className: "radio-label", htmlFor: id}, this.props.label)));
    };
    return RadioInput;
}(React.Component));
exports.RadioInput = RadioInput;
