"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
var _ = require("underscore");
var dateHelpers_1 = require('./../../../utilities/dateHelpers');
var grid_1 = require("./../../layout/grid");
var binder_1 = require("./../binder");
var classNames = require("classnames");
var TimeInput = (function (_super) {
    __extends(TimeInput, _super);
    function TimeInput() {
        _super.call(this);
        this.state = { hours: null, minutes: null };
    }
    TimeInput.prototype.componentWillMount = function () {
        var t = this.props.data[this.props.prop];
        if (t) {
            var time = dateHelpers_1.DateHelpers.getTimeParts(t);
            this.setState({ hours: time.hours, minutes: time.minutes });
        }
    };
    TimeInput.prototype.hourChanged = function (hour) {
        var _this = this;
        var hours = parseInt(hour);
        this.setState({ hours: hours }, function () {
            _this.updateTime();
        });
    };
    TimeInput.prototype.minuteChanged = function (minute) {
        var _this = this;
        var minutes = parseInt(minute);
        this.setState({ minutes: minutes }, function () {
            _this.updateTime();
        });
    };
    TimeInput.prototype.change = function () {
        binder_1.Binder.handleChange(this.props.prop, this.state.hours + ":" + this.state.minutes, "string", this.props.data);
        this.props.context.forceUpdate();
    };
    TimeInput.prototype.updateTime = function () {
        this.change();
    };
    TimeInput.prototype.componentWillReceiveProps = function (newProps) {
        var newT = newProps.data[this.props.prop];
        if (newT) {
            var newTime = dateHelpers_1.DateHelpers.getTimeParts(newT);
            var hours = this.state.hours;
            var minutes = this.state.minutes;
            var needsUpdate = void 0;
            if (newTime.hours !== hours) {
                hours = newTime.hours;
                needsUpdate = true;
            }
            if (newTime.minutes !== minutes) {
                minutes = newTime.minutes;
                needsUpdate = true;
            }
            if (needsUpdate) {
                this.setState({ hours: hours, minutes: minutes });
            }
        }
        else {
            this.setState({ hours: null, minutes: null });
        }
    };
    TimeInput.prototype.render = function () {
        var _this = this;
        var hours = _.range(0, 24, 1);
        var minutes = _.range(0, 60, 1);
        return React.createElement(grid_1.Grid, {className: classNames("time-input", this.props.className)}, 
            React.createElement(grid_1.Row, null, 
                React.createElement(grid_1.Col, null, 
                    React.createElement("select", {disabled: this.props.disabled, onChange: function (e) { return _this.hourChanged(e.target.value); }, value: this.state.hours !== undefined ? this.state.hours.toString() : ""}, 
                        React.createElement("option", {disabled: true, value: ""}, "HH"), 
                        hours.map(function (d) { return React.createElement("option", {key: d.toString(), value: d.toString()}, d < 10 ? "0" + d : d); }))
                ), 
                React.createElement(grid_1.Col, null, 
                    React.createElement("select", {disabled: this.props.disabled, onChange: function (e) { return _this.minuteChanged(e.target.value); }, value: this.state.minutes !== undefined ? this.state.minutes.toString() : ""}, 
                        React.createElement("option", {disabled: true, value: ""}, "MM"), 
                        minutes.map(function (d) { return React.createElement("option", {key: d.toString(), value: d.toString()}, d < 10 ? "0" + d : d); }))
                ))
        );
    };
    return TimeInput;
}(React.Component));
exports.TimeInput = TimeInput;
