"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var _ = require("underscore");
var classNames = require("classnames");
var binder_1 = require("./../binder");
var ToggleInput = (function (_super) {
    __extends(ToggleInput, _super);
    function ToggleInput() {
        _super.call(this);
        this.state = { switchedOn: false };
    }
    ToggleInput.prototype.toggleSwitch = function () {
        var _this = this;
        var newState = !this.state.switchedOn;
        this.setState({ switchedOn: newState }, function () {
            _this.change(_this.state.switchedOn);
        });
    };
    ToggleInput.prototype.componentWillReceiveProps = function (newProps) {
        var switchedOn = newProps.data[this.props.prop];
        if (switchedOn !== this.state.switchedOn) {
            this.setState({ switchedOn: switchedOn });
        }
    };
    ToggleInput.prototype.componentWillMount = function () {
        this.setState({ switchedOn: this.props.data[this.props.prop] });
    };
    ToggleInput.prototype.change = function (on) {
        binder_1.Binder.handleChange(this.props.prop, on, "boolean", this.props.data);
        this.props.context.forceUpdate();
    };
    ToggleInput.prototype.render = function () {
        var _this = this;
        var attrs = _.omit(this.props, "onLabel", "offLabel", "className");
        var classes = classNames("toggle-input", this.props.className);
        return (React.createElement("div", {className: classes}, 
            React.createElement("div", __assign({className: classNames({ "toggled-on": this.state.switchedOn })}, attrs, {onClick: function () { return _this.toggleSwitch(); }, title: "" + (this.state.switchedOn ? (this.props.onLabel || "ON") : (this.props.offLabel || "OFF"))})), 
            this.props.label && React.createElement("label", null, this.props.label)));
    };
    return ToggleInput;
}(React.Component));
exports.ToggleInput = ToggleInput;
